# SWAP-meteo
# Wageningen Environmental Research
# waterwijzerlandbouw@wur.nl
#------------------------------------------------

# set start of program
TIMPRGSTART <- Sys.time()

# ---- arguments ----

# set modus
test <- FALSE

# load arguments
if (!test) {
  command_args <- commandArgs(trailingOnly = TRUE)
  if (length(command_args) != 1) {
    stop("wrong usage of script, arguments should be:\n- controlfile")
  }
} else {
  command_args <- NULL
  command_args[1] <- "control_meteo.inp"
  setwd("d:/Regionaal")
}

# set arguments
ctrl <- command_args[1]

# ---- load libraries ----

source("Tools/R/Libraries.R")

message("\nProgam R-PROG started...\n")

# ---- pre-process ----

# set directories
dir_out <- get_dir(file = ctrl, item = "DIROUT", create = FALSE)

# set station KNMI
station <- get_record(file = ctrl, item = "STATION")
replace <- get_record(file = ctrl, item = "REPLACE", item_exists = FALSE)

# set period
tstart <- get_record(file = ctrl, item = "TSTART")
tend <- get_record(file = ctrl, item = "TEND")

# split met-files
record <- get_record(file = ctrl, item = "SPLIT", opt = c("Yes", "No"), item_exists = FALSE)
if (is.null(record)) record <- "No"
split <- ifelse(record == "Yes", TRUE, FALSE)

# ---- main-process ----

# create met-file(s)
create_meteo_SWAP(dir_out = dir_out, station = station, tstart = tstart, tend = tend, split = split, replace = replace)

# ---- return of procedure ----

TIMPRGEND <- Sys.time()
TIMPRGCALC <- as.numeric(difftime(time1 = TIMPRGEND, time2 = TIMPRGSTART, units = "secs"))
message(paste0("\nProgam R-PROG successfully ended in ", floor(TIMPRGCALC / 60), " minutes and ", ceiling(TIMPRGCALC %% 60), " seconds"))
q(save = "no")
